import cdk = require('@aws-cdk/cdk');
/**
 * A cluster parameter group
 */
export declare abstract class ClusterParameterGroupRef extends cdk.Construct {
    /**
     * Import a parameter group
     */
    static import(scope: cdk.Construct, id: string, props: ClusterParameterGroupRefProps): ClusterParameterGroupRef;
    /**
     * Name of this parameter group
     */
    abstract readonly parameterGroupName: string;
    /**
     * Export this parameter group
     */
    export(): ClusterParameterGroupRefProps;
}
/**
 * Properties to reference a cluster parameter group
 */
export interface ClusterParameterGroupRefProps {
    parameterGroupName: string;
}
